# c446.py  v0.4 Author: JF Bouchaudy, Licence: GPL
# a faire (to do):
#<-> corriger bug: import: il faut 27 barres
#<-> corriger bug: quand on imprime (version cle imprimable) pas besoin de 27 barres
#<-> corriger bug: overlaps doivent etre coherent avec les lugs: OK
#<-> corriger bug: le compteur a 1000
#<-> corriger bug: deplacement sur linux
# -  Ajouter au presse-papier (saisie du texte)
# -  Essayer de faire un package (un Linux, un Windows)
#[-] prevoir mettre lugs via barres 
# -  modifier le texte: "Blair's Key"

import sys
import string
import time
from Tkinter import *
from tkMessageBox import *
from tkFileDialog import *

from c446classes import *
import c446_makekey
import c446_pkey 

#======== classe graphique
class ScrolledText(Frame):
	def __init__(self, parent=None, text='', file=None):
		Frame.__init__(self, parent)
		self.pack(expand=YES, fill=BOTH)
		self.makewidgets()
		self.settext(text, file)
	def	makewidgets(self):
		sbar = Scrollbar(self)
		text = Text(self, relief=SUNKEN)
		sbar.config(command=text.yview)
		text.config(yscrollcommand=sbar.set)
		text.config(font=('courier',16,'normal'))
		sbar.pack(side=RIGHT, fill=Y)
		text.pack(side=LEFT, expand=YES, fill=BOTH)
		self.text = text
	def	settext(self, text='', file=None):
		if file:
			text = open(file,'r').read()
		self.text.delete('1.0', END)
		self.text.insert('1.0', text)
		self.text.mark_set(INSERT, '1.0')
		self.text.focus()
	def	reflexe():
		print "OK"
	def	gettext(self):
		return self.text.get('1.0', END+'-1c')


#========
def save(nomFichier):
	global keymodified 
	#nomFichier = raw_input("Nom du fichier (config par defaut) ? ")
	if nomFichier == "":
		nomFichier = "config"

	try:
		f = open( nomFichier, "w" )
	except:
		showinfo("Error","Impossible to open file")
		return
	
	for i in range(6):
		ch = c.getPinsOfAWheel( i )
		f.write( ch + '\n' )
	
	ch = c.getLetterShift()
	f.write( ch + '\n' )

	ch = ""
	lesLugs = c.getLugs()
	for i in range(5):
		ch = ch + str(lesLugs[i]) + ":"
	ch = ch + str(lesLugs[5])
	f.write( ch + '\n' )
	

	o = c.getOver()
	nbOverlaps = 0
	lesOverlaps = []
	for clef in sorted( o.keys() ):
		val = o[clef]
		if val > 0:
			lesOverlaps.append( clef + ":" + str(val) )
			nbOverlaps = nbOverlaps + 1
	f.write( str( nbOverlaps ) + '\n' )
	for ligne in lesOverlaps :
		f.write( ligne + '\n' )
	f.close()
	keymodified = 0
	print "====> Sauvegarde effectuee"

def restore(nomFichier):
	#nomFichier = raw_input("Nom du fichier (config par defaut) ? ")
	if nomFichier == "":
		nomFichier = "config"
	try:
		f = open( nomFichier, "r" )
	except:
		if nomFichier == "conf_c446" :
			return
		showinfo("Error","Impossible to open file")
		return

	try:
		c.zero()
		for i in range(6):
			ch = f.readline()
			print ch
			ch = ch.rstrip()
			lg = len(ch)
			for j in range(lg):
				if ch[j] != '_':
					c.setPinsON(i, ch[j] )

		ch = f.readline()
		ch = ch[0]
		c.setLetterShift( ch )
		print c.getLetterShift()
	
		ch = f.readline()
		ch = ch.rstrip()
		Lugs = ch.split(":")
		Lugs = map(int,Lugs)
		print Lugs
	
		c.setLugs( Lugs )
		ch = f.readline()
		nblignes = int (ch )
		for i in range( nblignes ):
			ch = f.readline()
			ch = ch.rstrip()
			(over_clef, over_nb) = ch.split(":")
			over_nb = int(over_nb)
			c.setOverByKey(over_clef, over_nb)
			print over_clef, over_nb
	except:
		showinfo("Error","Impossible to read the file")
		menu_nouveau()
		return
	finally:
		f.close()

#========
def is_maj(car):
	if string.find(string.ascii_uppercase,car) == -1: 
		return 0
	else:
		return 1

def menu_cipher():
    try:
	c.toggleDebug()
	ch = compteur.selection_get(selection="CLIPBOARD")
	ch = ch.upper()
	for j in range(len(ch)):
		if not is_maj(ch[j]):
			continue
		GUI_clair.set( ch[j] )
		chiffrer()
	return
    except:
	showinfo("?", "Problem during ciphering")
	#print "impossible to copy from clip"
    finally:
	c.toggleDebug()

def r(roue):
	c.stepAWheel( roue )
	r3l(roue)

def r3l(roue):
	tb = c.getLetters( roue )
	troisLettres = tb[0] + '\n' + tb[1] + '\n' + tb[2] 
	wheel[ roue ].configure(text=troisLettres)

def lmoins(j):
	global lesLugs, lugsLessOver
	if lesLugs[j] > 0 and lugsLessOver[j] > 0:
		lesLugs[j] = lesLugs[j] - 1
		lugsLessOver[j] = lugsLessOver[j] - 1
		labelLesLugs[j].configure(text=str(lesLugs[j]))

def lplus(j):
	global lesLugs, lugsLessOver
	lesLugs[j] = lesLugs[j] + 1
	lugsLessOver[j] = lugsLessOver[j] + 1
	labelLesLugs[j].configure(text=str(lesLugs[j]))

def loverMoins(j):
	global lesOverlaps, labelClefLesOverlaps, labelValLesOverlaps, lugsLessOver
	val = int( labelValLesOverlaps[j].cget('text') )
	if val > 0:
		val = val - 1
		labelValLesOverlaps[j].configure(text=str(val))
		cle = labelClefLesOverlaps[j].cget('text')
		n1 = int( cle[0] ) 
		n2 = int( cle[2] )
		lugsLessOver[ n1 - 1 ] += 1
		lugsLessOver[ n2 - 1 ] += 1

def loverPlus(j):
	global lesOverlaps, labelClefLesOverlaps, labelValLesOverlaps, lugsLessOver
	val = int( labelValLesOverlaps[j].cget('text') )
	cle = labelClefLesOverlaps[j].cget('text')
	n1 = int( cle[0] ) 
	n2 = int( cle[2] )
	#print "loverPlus:", cle, n1, n2, val, lugsLessOver
	if lugsLessOver[ n1 - 1] < 1 or lugsLessOver[ n2 - 1 ] < 1: 
		return
	lugsLessOver[ n1 - 1 ] -= 1
	lugsLessOver[ n2 - 1 ] -= 1
	val = val + 1
	labelValLesOverlaps[j].configure(text=str(val))

def ldelplus(lab):
	global lettreSeparateur
	lettre = lab.cget('text')
	i = string.index( ALPHA, lettre )
	lettre = ALPHA[ (i+1) % 26 ]
	lettreSeparateur = lettre
	lab.configure(text=lettre)

def ldelmoins(lab):
	global lettreSeparateur
	lettre = lab.cget('text')
	i = string.index( ALPHA, lettre )
	lettre = ALPHA[ (26 + i - 1) % 26 ]
	lettreSeparateur = lettre
	lab.configure(text=lettre)

def ldecaplus(lab):
	global keymodified
	lettre = lab.cget('text')
	i = string.index( ALPHA, lettre )
	lettre = ALPHA[ (i+1) % 26 ]
	c.setLetterShift( lettre )
	lab.configure(text=lettre)
	keymodified = 1
	knob()

def ldecamoins(lab):
	global keymodified
	lettre = lab.cget('text')
	i = string.index( ALPHA, lettre )
	lettre = ALPHA[ (26 + i - 1) % 26 ]
	c.setLetterShift( lettre )
	lab.configure(text=lettre)
	keymodified = 1
	knob()

def lcopier(lab):
	lab.clipboard_clear()
	lab.clipboard_append( lab.cget('text') )

def knob():
	lettre_clair = GUI_clair.get()
	print "knob: ", lettre_clair
	if len(lettre_clair) > 1 : return
	if not lettre_clair.isalpha(): return
	i = string.index( ALPHA , lettre_clair )
	new_clair = ALPHA[ (i+1)%26 ]
	knob_ver_rev( new_clair )

def knob_rev():
	lettre_clair = GUI_clair.get()
	print "knob: ", lettre_clair
	if len(lettre_clair) > 1 : return
	if not lettre_clair.isalpha(): return
	i = string.index( ALPHA, lettre_clair )
	new_clair = ALPHA[  (26 + i -1)%26 ]
	knob_ver_rev( new_clair )

def knob_ver_rev( new_clair ):
	lettre_decal = c.getLetterShift()
	id = string.index( ALPHA, lettre_decal )
	GUI_clair.set( new_clair )
	clair.configure( text=new_clair) 
	i = string.index( ALPHA, new_clair )
	lettre_crypto = "ZYXWVUTSRQPONMLKJIHGFEDCBA"[ (26 + i - id -1)%26 ]
	crypto.configure(text=lettre_crypto)
	print "knob_ver_rev:", new_clair, lettre_crypto, id

def chiffrer():
	global textesaisie, texteresultat, modeCoD, lettreSeparateur, cpt
	lettre_clair = GUI_clair.get()
	lettre_crypto = c.cipher( lettre_clair )
	if modeCoD == 'C':
		if cpt%5 == 0 and textesaisie != "":
			textesaisie += " " 
			texteresultat += " "
		textesaisie = textesaisie + lettre_crypto
	else:
		if lettre_crypto == lettreSeparateur :
			textesaisie += " "
		else:
			textesaisie = textesaisie + lettre_crypto
	texteresultat = texteresultat + lettre_clair
	crypto.configure(text=lettre_crypto)
	i = string.index( ALPHA , lettre_crypto )
	lettre_decal = c.getLetterShift()
	id = string.index( ALPHA, lettre_decal )
	lettre_clair = "ZYXWVUTSRQPONMLKJIHGFEDCBA"[ (26 + i - id - 1)%26 ]
	GUI_clair.set( lettre_clair )
	clair.configure(text=lettre_clair)
	majAffichage()
	cpt = cpt + 1
	fond.move( fenetre_levier, 0, 150 )
	fond.update()
	time.sleep(0.2)
	fond.move( fenetre_levier, 0,-150 )

def recule():
	c.stepBack()
	majAffichage()

def majAffichage():
	for i in range(6):
		#lettre = c.getKeyOfAWheel(i)
		#wheel[i-1].configure(text=lettre)

		tb = c.getLetters(i)
		troisLettres = tb[0] + '\n' + tb[1] + '\n' + tb[2] 
		wheel[i].configure(text=troisLettres)

	position = c.getPosition()
	compteur.configure(text=str("%04d" % (position)))

def menu_():
	print "MENU"

def menu_interne_pins():
	global lesPins, win
	print "histo"
	win = Toplevel(pere)
	win.title('Setting Pins')
	aff = []
	aff.append( "ABCDEFGHIJKLMNOPQRSTUVWXYZ" )
	aff.append( "ABCDEFGHIJKLMNOPQRSTUVXYZ" )
	aff.append( "ABCDEFGHIJKLMNOPQRSTUVX" )
	aff.append( "ABCDEFGHIJKLMNOPQRSTU" )
	aff.append( "ABCDEFGHIJKLMNOPQRS" )
	aff.append( "ABCDEFGHIJKLMNOPQ" )

	lesPins = []
	for i in range(6):
		lesPins.append( [] )
		for j in range( len(aff[i]) ):
			indice = i*100 + j
			aPins = c.getPins(i,aff[i][j])
			if aPins:
				leRelief = 'flat'
			else:
				leRelief = 'sunken'
			l = Label(win, text=aff[i][j], relief= leRelief, font=('Courier'))
			l.grid(row=i, column=j, sticky=NSEW)
			l.bind('<ButtonRelease>', reflexe )
			lesPins[i].append( l )
	Button(win, text='  OK   ', command=ok_pins).grid(columnspan=10, sticky=W)

def menu_interne_lugs():
	global win2, lesLugs, lugsLessOver, labelLesLugs, lesOverlaps, labelClefLesOverlaps, labelValLesOverlaps
	print "lugs"
	win2 = Toplevel(pere)
	win2.title('Setting Lugs')
	lesLugs = c.getLugs()
	lugsLessOver = list( lesLugs )
	print "les lugs : ", lesLugs
	labelLesLugs= []
	boutonMoins = []
	boutonPlus  = []
	for j in range( len(lesLugs )):
		labelLesLugs.append( Label(win2, text=lesLugs[j],font=('Courier')) )
		labelLesLugs[j].grid(row=j,column=0,sticky=NSEW)
		
		boutonMoins.append(Button(win2, text='-', command=lambda lug=j : lmoins(lug) ))
		boutonMoins[j].grid(row=j,column=1,sticky=NSEW)

		boutonPlus.append(Button(win2, text='+', command=lambda lug=j : lplus(lug) ))
		boutonPlus[j].grid(row=j,column=2,sticky=NSEW)
		Label(win2, text=' lugs in front of wheel ' + str(j+1)).grid(row=j,column=3,sticky=NSEW)
	o = c.getOver()
	labelClefLesOverlaps = [] ; labelValLesOverlaps = []; lesOverlaps = []; i = 0; ligne= j + 1
	for clef in sorted( o.keys() ):
		lesOverlaps.append( clef )
		labelClefLesOverlaps.append( Label(win2, text=clef) )
		labelClefLesOverlaps[i].grid(row=ligne+i,column=0,sticky=NSEW) 
		labelValLesOverlaps.append( Label(win2, text=str(o[clef])) )
		labelValLesOverlaps[i].grid(row=ligne+i,column=1,sticky=NSEW)
		Button(win2,text='-', command=lambda num=i: loverMoins(num)).grid(row=ligne+i,column=2,sticky=NSEW)
		Button(win2,text='+', command=lambda num=i: loverPlus(num)).grid(row=ligne+i,column=3,sticky=NSEW)
		Label(win2,text=" Overlap ").grid(row=ligne+i,column=4,sticky=NSEW)
		i = i + 1
	Button(win2, text=' OK ',command=ok_lugs).grid(columnspan=10,sticky=W)

def reflexe(evt):
	global lesPins
	print "Reflexe", (evt.widget).cget('text')
	relief = (evt.widget).cget('relief')
	if relief == 'flat':
		(evt.widget).configure(relief='sunken')
	else:
		(evt.widget).configure(relief='flat')

def ok_pins():
	global lesPins, win, keymodified
	for i in range(6):
		for j in range( len(lesPins[i] ) ):
			relief = lesPins[i][j].cget('relief')
			lettre = lesPins[i][j].cget('text')
			if relief == 'flat':
				print 1,
				c.setPinsON(i, lettre )
			else:
				print 0,
				c.setPinsOFF(i, lettre )
		print
	print
	keymodified = 1
	win.destroy()


def ok_lugs():
	global lesLugs, win2, lesOverlaps, labelValLesOverlaps, keymodified
	c.setLugs( lesLugs )
	print "les lugs: ", c.getLugs()
	for i in range( len(lesOverlaps) ):
		val = int( labelValLesOverlaps[i].cget('text') )
		print lesOverlaps[i], '->', val
		c.setOverByKey( lesOverlaps[i], val )
	print c.getOver()
	keymodified = 1
	win2.destroy()

def mode():
	global modeCoD
	m = modecd.cget('text')
	if m == 'C':
		modecd.configure(text='D')
		modeCoD = 'D'
	else:
		modecd.configure(text='C')
		modeCoD = 'C'
	print m

def onKeyPress(evt):
	car = evt.keysym
	print "+++", car
	if car == 'Left' or car == 'Right':
		mode();
		return
	if car == 'Up':
		knob_rev()
		return
	if car == 'Down':
		knob()
		return
	if car == 'Shift_L' or car == 'Shift_R' or car == 'BackSpace' :
		recule()
		return
	if car == 'Return' or car == 'KP_Enter':
		chiffrer()
		return
	if len(car) == 1 and car.isalpha() :
		print ">>>>>", car.upper()
		GUI_clair.set( car.upper() )
		clair.configure( text=car.upper()) 
		chiffrer()
		return
	return

def menu_nouveau():
	global lettreSeparateur, modeCoD
	c.zero()
	menu_zero()

def menu_zero():
	c.reinit()
	menu_detache()
	majAffichage()
	print "========> Remise a zero"

def menu_retour():
	c.rewind()
	majAffichage()

def menu_bande():
	global textesaisie, texteresultat
	print textesaisie
	print texteresultat
	win2 = Toplevel(pere)
	win2.title('Cipher/Decipher')
	st1 = Label(win2, text=textesaisie, bg='white', font=('Courier') )
	st1.pack()
	st2 = Label(win2, text=texteresultat, bg='white', font=('Courier') )
	st2.pack()
	Button(win2, text='copy output (top) tape to the clipboard', command=lambda lab=st1: lcopier(lab)).pack()
	Button(win2, text='copy input (bottom) tape to the clipboard', command=lambda lab=st2: lcopier(lab)).pack()
	win2.protocol('WM_DELETE_WINDOW', win2.destroy )

def menu_espace():
	global textesaisie, texteresultat
	textesaisie += "   "
	texteresultat += "   "

def menu_detache():
	global textesaisie, texteresultat, cpt
	textesaisie = ""
	texteresultat= ""
	cpt = 0

def menu_delimiter():
	global win3, lettreSeparateur
	print "Delimiter"
	win3 = Toplevel(pere)
	win3.title('Delimiter letter')
	l = Label(win3, text=lettreSeparateur,font=('Courier'))
	l.grid(row=0,column=0,sticky=NSEW)
	Button(win3, text='-', command=lambda lab=l : ldelmoins(lab) ).grid(row=0,column=1,sticky=NSEW)
	Button(win3, text='+', command=lambda lab=l : ldelplus(lab) ).grid(row=0,column=2,sticky=NSEW)	

def menu_decalage():
	global win4
	print "Shift letter"
	win4 = Toplevel(pere)
	win4.title('Shift letter')
	l = Label(win4, text=c.getLetterShift(),font=('Courier'))
	l.grid(row=0,column=0,sticky=NSEW)
	Button(win4, text='-', command=lambda lab=l : ldecamoins(lab) ).grid(row=0,column=1,sticky=NSEW)
	Button(win4, text='+', command=lambda lab=l : ldecaplus(lab) ).grid(row=0,column=2,sticky=NSEW)	

def menu_printkey():
	oldKey= c.getExternalKey()
	c.toggleDebug()
	oldposi = c.getPosition()
	c.setExternalKey("AAAAAA")
	ch = c446_pkey.printKey(c)
	win5 = Toplevel(pere)
	win5.title('Printable Key')
	l = Label(win5, text=ch,font=('Courier'), bg='wheat')
	l.pack()
	Button(win5, text='Copy to clipboard', command=lambda lab=l : lcopier(lab) ).pack()
	c.toggleDebug()
	c.setExternalKey( oldKey )
	c.setPosition( oldposi )

def menu_histo():
	ch = c.getHistory()
	win = Toplevel(pere)
	win.title('History')
	st = ScrolledText( parent=win, text=ch)
	win.protocol('WM_DELETE_WINDOW', win.destroy )

def menu_ouvrir():
	restore("conf_c446")

def menu_ouvre_comme():
	nomFichier = askopenfilename(defaultextension='key', filetypes= \
		[('Key file','.key')] )
	if ( nomFichier == "" ): return
	if ( nomFichier != None ):
		restore(nomFichier)

def menu_export():
	nomFichier = asksaveasfilename(defaultextension='m209key', filetypes= \
		[('Blair Key file','.m209key')] )
	if ( nomFichier == "" ): return
	if ( nomFichier != None ):
		try:
			f = open( nomFichier, "w" )
			c446_pkey.exportBlair( c, f )
			f.close()
		except:
			showinfo("?", "Problem during exportation")

def menu_import():
	nomFichier = askopenfilename(defaultextension='m209key', filetypes= \
		[('Blair Key file','.m209key')] )
	if ( nomFichier == "" ): return
	if ( nomFichier != None ):
		ch = c446_pkey.importBlair( c, nomFichier)	
		if ch != "":
			showinfo("?", "Problem during importation")

def menu_sauver():
	save("conf_c446")

def menu_sauve_comme():
	nomFichier = asksaveasfilename(defaultextension='key', filetypes= \
		[('Key file','.key')] )
	if ( nomFichier == "" ): return
	if ( nomFichier != None ):
		save(nomFichier)

def menu_properties():
	showinfo("Information", \
		"C446A\n" + \
		"-----------------------------------------------\n" +
		"V 0.4, JF Bouchaudy, , Licence GPL\n" +
		"-----------------------------------------------\n" +
		"Simulator of C446A cipher machine.\n" + \
		"If shift letter is set to 'Z' it emulates a M209.\n" +
		"-----------------------------------------------\n" +
		"Email: jfbouch@wanadoo.fr" )

def menu_newkey():
	menu_nouveau()
	f = open("conf_c446","w")
	c446_makekey.newKey(f)
	f.close()
	restore("conf_c446")

def menu_quit():
	if keymodified:
		ch = askokcancel('Quitter', "Are you sure (the confirguration was modified) ?")
		if ch:	
			menu_sauver()
		else:
			return
	sys.exit(0)

#========= DEBUT DU PROGRAMME ===================================

#global lastX, lastY
#lastX=0 ; lastY=0
ALPHA = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
textesaisie = ""
texteresultat= ""
history = ""
cpt=0
modeCoD = 'C'
lettreSeparateur = 'Z'
keymodified = 0
c = c446( lettreSeparateur, 1)
#=========
pere = Tk()
GUI_clair = StringVar()
GUI_clair.set('A')

# ---- menu
pereMenu = Menu(pere)
pere.config(menu=pereMenu)
file= Menu(pereMenu, tearoff=0)
file.add_command(label='New', command=menu_nouveau, underline=0)
file.add_command(label='Open',command=menu_ouvrir, underline=0)
file.add_command(label='Open Key File',command=menu_ouvre_comme, underline=7)
file.add_command(label='Save', command=menu_sauver, underline=0)
file.add_command(label='Save Key File as', command=menu_sauve_comme, underline=7)
file.add_separator()
file.add_command(label='Import Blair Key', command=menu_import, underline=0)
file.add_command(label='Export Blair Key', command=menu_export, underline=0)
file.add_separator()
file.add_command(label='Exit', command=menu_quit, underline=0)
sett= Menu(pereMenu, tearoff=0)
sett.add_command(label='Zeroizing', command=menu_nouveau, underline=0)
sett.add_separator()
sett.add_command(label='Setting key wheel pins', command=menu_interne_pins, underline=0)
sett.add_command(label='Setting key lugs', command=menu_interne_lugs, underline=0)
sett.add_command(label='Setting shift letter', command=menu_decalage, underline=0)
sett.add_separator()
sett.add_command(label='Generate New key', command=menu_newkey, underline=0)
sett.add_command(label='Printable Key', command=menu_printkey, underline=0)
affi= Menu(pereMenu, tearoff=0)
affi.add_command(label='Letter spacing', command=menu_delimiter, underline=0)
affi.add_command(label='Tapes', command=menu_bande, underline=0)
affi.add_command(label='Advance tapes', command=menu_espace, underline=0)
affi.add_command(label='Cut tapes', command=menu_detache, underline=0)
affi.add_separator()
affi.add_command(label='History', command=menu_histo, underline=0)
extk= Menu(pereMenu, tearoff=0)
extk.add_command(label='Ready to check (AAAAAA)', command=menu_zero, underline=0)
extk.add_command(label='Come-back (Counter:0000)', command=menu_retour, underline=0)
extk.add_separator()
extk.add_command(label='To cipher from clipboard', command=menu_cipher, underline=0)
hlpm= Menu(pereMenu, tearoff=0)
hlpm.add_command(label='About ...', command=menu_properties, underline=0)
pereMenu.add_cascade(label='File', menu=file, underline=0)
pereMenu.add_cascade(label='Internal Key', menu=sett, underline=0)
pereMenu.add_cascade(label='Display', menu=affi, underline=0)
pereMenu.add_cascade(label='External Key', menu=extk, underline=0)
pereMenu.add_cascade(label='?', menu=hlpm, underline=0)

# ---- le fond
fond = Canvas(pere, width=500, height=500, bg='cyan')
photo = PhotoImage(file='c446.gif')
fond.create_image(250,250, image = photo )
fond.pack(expand=YES, fill=BOTH)
fond.create_line(210,400,430,400, width=2, fill='white')
wheel = []
wheel.append( Button( fond, text='-\n-\n-', bg='white', font=('Courier'), \
		command=lambda roue=0 : r(roue) ))
wheel.append( Button( fond, text='A\nB\nC', bg='white', font=('Courier'), \
		command=lambda roue=1 : r(roue) ))
wheel.append( Button( fond, text='A\nB\nC', bg='white', font=('Courier'), \
		command=lambda roue=2 : r(roue) ))
wheel.append( Button( fond, text='A\nB\nC', bg='white', font=('Courier'), \
		command=lambda roue=3 : r(roue) ))
wheel.append( Button( fond, text='A\nB\nC', bg='white', font=('Courier'), \
		command=lambda roue=4 : r(roue) ))
wheel.append( Button( fond, text='A\nB\nC', bg='white', font=('Courier'), \
		command=lambda roue=5 : r(roue) ))

for i in range(len(wheel)):
	r3l(i)
	wheel[i].pack()
fond.create_window(240,400, window=wheel[0])
fond.create_window(270,400, window=wheel[1])
fond.create_window(300,400, window=wheel[2])
fond.create_window(330,400, window=wheel[3])
fond.create_window(360,400, window=wheel[4])
fond.create_window(390,400, window=wheel[5])
compteur = Label( fond, text='0000', bg='black', fg='white' )
modecd =  Button( fond, text="C", bg='grey', command=mode )
clair =  Button( fond, text="A", bg='white', command=knob )
crypto = Label( fond, text='Z', bg='white', font=('Courier') )
chiffre = Button( fond, text='       ', bg='black', command=chiffrer )
retour  = Button( fond, text='     ', bg='grey',  command=recule)
clair.pack()
crypto.pack()
chiffre.pack()
fond.create_window( 50,367, window=modecd)
fond.create_window(185,350, window=compteur)
fond.create_window( 75,435, window=clair)
fond.create_window(120,385, window=crypto)
fenetre_levier = fond.create_window(455,300, window=chiffre)
fond.create_window(450,400, window=retour)

pere.bind("<KeyPress>", onKeyPress)
pere.protocol("WM_DELETE_WINDOW",menu_quit)
#menu_ouvrir()
mainloop()
