# make_key.py : cree un tableau de cle

import random
import sys
import string

def afficheTableau( tb ):
	for i in range(1,133):
		if i == 1 or i == 27 or i == 52 or i == 75 or i == 96 or i == 115:
			print
		print tb[i],
	print	


def serieLongue( tb, lg ):
	suite = 0
	n0 = 0
	n1 = 0
	change = []
	if tb[0] == 0:
		suite = 0
		n0 = 1
	else:
		suite = 1
		n1 = 1
	for i in range(1, len(tb) ):
		if n0 >= lg or n1 >= lg :
			# print "<",change, i,">"
			return 1
		if suite == 0 and tb[i] == 0 : 
			n0 = n0 + 1
			continue
		if suite == 1 and tb[i] == 1 :
			n1 = n1 + 1
			continue
		change.append( i )
		if suite == 0 :
			suite = 1
			n1 = 1
		else:
			suite = 0
			n0 = 1		
	return 0

def newKey(f):
	# ====> les Pins

	wheels = []

	wheels.append( "ABCDEFGHIJKLMNOPQRSTUVWXYZ" )
	wheels.append( "ABCDEFGHIJKLMNOPQRSTUVXYZ" )
	wheels.append( "ABCDEFGHIJKLMNOPQRSTUVX" )
	wheels.append( "ABCDEFGHIJKLMNOPQRSTU" )
	wheels.append( "ABCDEFGHIJKLMNOPQRS" )
	wheels.append( "ABCDEFGHIJKLMNOPQ" )

	tb = []
	while 1:
   		tb = [0] * 78 + [1] * 78 

   		random.shuffle( tb )
   		random.shuffle( tb )
   		random.shuffle( tb )
   		random.shuffle( tb )

		flag = 0
		ttemp = []
		newtb = []
		for i in range(1,134):
			if i == 1 or i == 27 or i == 52 or i == 75 or i == 96 or i == 115 or i == 133 :
				if len( ttemp ) != 0:
					newtb = list( ttemp ) + list( ttemp )
					if serieLongue( newtb, 6 ) :
						# print ">>>", i, newtb
						flag = 1
						break
				ttemp = []	
 			ttemp.append( tb[i] )

   		if flag == 1: 
			#print "Error: serie longue: "
			continue
   		break     
	# afficheTableau( tb )
	k = 1
	for i in range(6):
		ch = ""
		for j in range( len( wheels[i]) ): 
			if tb[k] :
				ch += wheels[i][j]
			else:
				ch += "_"
			k += 1	
		f.write( ch + '\n' )

	
	# =====> la lettre shift
	lettre = string.uppercase[ random.randint(0,25) ]
	f.write( lettre + '\n' )

	# =====> Les lugs
	lugs = [0,0,0,0,0,0]
	flag = 1

	while 1:
		# ====> Cree 6 lugs au hazard (au moins un lug a la valeur "1"
		lugs = [ 1, 0, 0, 0, 0, 0 ]
		for i in range(1,6):
			lugs[i] = ( random.randint(1,13) )

		# ====> somme des lugs >= 28 et <= 39
		somme = 0
		for i in range(6):
			somme = somme + lugs[i]
		if not( somme >= 28 and somme <= 39 ):
			# print "Error sum:", lugs
			continue 
		nbover = somme - 27

		# ====> on melange
		newlugs = []
		for i in range(6):
			val = random.choice( lugs )
			lugs.remove( val )
			newlugs.append( val )
		lugs = newlugs

		# ====> 3 lugs impair
		impair = 0
		for i in range(6):
			if (lugs[i] % 2) == 1:
				impair = impair + 1
		if impair != 3:
			# print "Error odd:", lugs
			continue

		# =====> Calculs des overlaps
		# print "Overlaps: ", nbover
		lugs2 = list( lugs )
		overlaps = { '1-2':0, '1-3':0, '1-4':0, '1-5':0, '1-6':0, '2-3':0, \
		     '2-4':0, '2-5':0, '2-6':0, '3-4':0, '3-5':0, '3-6':0, \
  		     '4-5':0, '4-6':0, '5-6':0 }	
		overkeys = overlaps.keys()
		flag = 0
		for i in range( nbover ):
			flag2 = 0
			for j in range(100000):
				un_over = random.choice( overkeys )
				n1 =  int( un_over[0] ) -1
				n2 =  int( un_over[2] ) -1
				if lugs2[n1] > 0 and lugs2[n2] > 2 :
					overlaps[ un_over ] += 1
					lugs2[n1] -= 1
					lugs2[n2] -= 1
					flag2 = 1
					break
			if flag2 == 0:
				flag = 1
				break
		if flag == 1: 
			# print "Error bcl", lugs, overlaps
			continue
		# print overlaps
	
		# =====> On verifie si on a toutes les valeurs de 1 a 27
		valeurs = [0] * 28
		valeurs[0] = 1
		for v in range(64):
			ch = bin(64 + v )
			activesPins = []
			for j in range(6):
				activesPins.append( int( ch[3 + j] ) )
			shift = 0
			for j in range( 6 ):
				shift = shift + activesPins[j] * lugs[j]
			o = overlaps
			shift = shift - o['1-2'] * activesPins[0] * activesPins[1]
			shift = shift - o['1-3'] * activesPins[0] * activesPins[2]
			shift = shift - o['1-4'] * activesPins[0] * activesPins[3]
			shift = shift - o['1-5'] * activesPins[0] * activesPins[4]
			shift = shift - o['1-6'] * activesPins[0] * activesPins[5]
			shift = shift - o['2-3'] * activesPins[1] * activesPins[2]
			shift = shift - o['2-4'] * activesPins[1] * activesPins[3]
			shift = shift - o['2-5'] * activesPins[1] * activesPins[4]
			shift = shift - o['2-6'] * activesPins[1] * activesPins[5]
			shift = shift - o['3-4'] * activesPins[2] * activesPins[3]
			shift = shift - o['3-5'] * activesPins[2] * activesPins[4]
			shift = shift - o['3-6'] * activesPins[2] * activesPins[5]		
			shift = shift - o['4-5'] * activesPins[3] * activesPins[4]
			shift = shift - o['4-6'] * activesPins[3] * activesPins[5]
			shift = shift - o['5-6'] * activesPins[4] * activesPins[5]
			valeurs[ shift ] = 1
		flag = 0
		for i in range(28):
			if valeurs[i] == 0: flag = 1
		if flag:
			# print "Error manque val", lugs, "\n", valeurs 
			continue				

		break
	ch = ""
	ch += "%d:%d:%d:%d:%d:%d" % (lugs[0],lugs[1],lugs[2],lugs[3],lugs[4],lugs[5])
	f.write( ch + '\n' )
	n = 0
	for x in sorted( overlaps.keys() ):
		if overlaps[x] > 0: n += 1
	f.write( str( n ) + '\n' )
	for x in sorted( overlaps.keys() ):	
		if overlaps[x] > 0:
			ch = "%s:%d" % (x, overlaps[x])
			f.write( ch + '\n' )

#=====================================================
if __name__ == "__main__":
	newKey( sys.stdout )
