# c446_scri.py 
# obj: cree une Hagelin de type C (M209, C446, ...)

import sys
from c446classes import *
from c446_pkey import restore
import string


# ===================================
def is_maj(car):
	if string.find(string.ascii_uppercase,car) == -1: 
		return 0
	else:
		return 1
#============================================
if len(sys.argv) < 3:
        print "syntax : c446_scri.py InternKey_file ExternKey [debug]"
        print "Example: echo AAAAA | python c446_scri.py MB AAAAAA"
	print "       the InternKey_file need to end by .key"
        sys.exit(1)
KEYINTERN= sys.argv[1]
KEYEXTERN= sys.argv[2]
if len(sys.argv) > 3: 
	debug = 1
else:
	debug = 0

c = c446( "Z", debug)
cryptogramme = ""
restore(c, KEYINTERN)
c.setExternalKey(KEYEXTERN)
if debug : c.info()

#--------------------------------------
leTexte = sys.stdin.readlines()
crypto = ""	
for i in range(len(leTexte)):
	ch = leTexte[i]
	ch = ch.upper()
	for j in range(len(ch)):
		if not is_maj(ch[j]):
			continue
		car = c.cipher(ch[j])
		crypto = crypto + car

print crypto